unit bobs;

INTERFACE

procedure init;
procedure done;
procedure go;

IMPLEMENTATION

uses main,Anima13,Mode13,Old3D,math,mem,Op386;

const
	TOTAL=2000;

	ALTO=6;ANCHO=system.round(ALTO*FIX_ASPECT_RATIO);

type
	TBobs=record
		x,y,z:integer;
	end;
	TaBobs=array[0..TOTAL] of Tbobs;

var
	b:^TaBobs;
	v:PObject;
	DecHeight,
	IncLeft,IncRight,
	IncY1:integer;
	s:TSprite;

procedure PutBobClipped(var s:TSprite);ASSEMBLER;
ASM
	LES			DI,s

	PUSH		BP
	MOV			BX,ES:TSprite[DI].n

	MOV			CX,0
	MOV			DecHeight,CX
	MOV			IncY1,CX
	MOV			IncLeft,CX
	MOV			IncRight,CX

	MOV			SI,WORD(SprInfo)
	MOV			AX,WORD(SprInfo+2)
	DW			MOV_GS_AX
	SHL			BX,3
	ADD			SI,BX

	MOV			DX,region.xul
	MOV			CX,ES:TSprite[DI].x
	MOV			AX,CX
	DB			GS;ADD		AX,WORD(TSprInfo[SI].width)
	CMP			AX,DX						{if x+ancho<region.xul then goto fin}
	JLE			@SALIR

	CMP			CX,DX   				{if x<region.xul then...}
	JGE			@SIGUE_X1

	MOV			AX,DX           {x:=region.xul;}
	SUB			AX,CX
	MOV			IncLeft,AX     {...dec(ancho,abs(region.xul-x);}

	MOV			CX,DX						{CX=x=region.xul}
	JMP			@SIGUE_X2

@SIGUE_X1:
	MOV			DX,region.xlr
	CMP			CX,DX   				{if x>region.xlr then goto fin}
	JGE			@SALIR

	CMP			AX,DX   				{if x+ancho>region.xlr then...}
	JL			@SIGUE_X2
	SUB			AX,DX
	MOV			IncRight,AX   	{dec(ancho,(x+ancho)-region.xlr}

@SIGUE_X2:
	MOV			DX,region.yul
	MOV			BX,ES:TSprite[DI].y
	MOV			AX,BX
	DB			GS;ADD		AX,WORD(TSprInfo[SI].height)
	CMP			AX,DX						{if y+alto<region.yul then goto fin}
	JLE			@SALIR

	CMP			BX,DX   				{if y<region.yul then...}
	JGE			@SIGUE_Y1
	MOV			AX,DX           {y:=region.yul;}
	SUB			AX,BX
	MOV			DecHeight,AX      {...dec(alto,abs(region.yul-y);}

	DB			GS;MOV		BP,WORD(TSprInfo[SI].width)
	IMUL		BP              {...inc(IncY1,abs(region.yul-y)*ancho);}
	MOV			IncY1,AX
	MOV			BX,region.yul		{...y:=region.yul}

@SIGUE_Y1:
	MOV			DX,region.ylr
	CMP			BX,DX   				{if y>region.ylr then goto fin}
	JGE			@SALIR

	MOV			AX,BX
	DB			GS;ADD		AX,WORD(TSprInfo[SI].height)
	CMP			AX,DX   				{if y+alto>region.ylr then...}
	JL			@SIGUE_Y2
	SUB			AX,DX
	DEC			AX
	MOV			DecHeight,AX  		{dec(alto,(y+alto)-region.ylr}
	JMP			@SIGUE_Y2

@SIGUE_Y2:      {BX=y, CX=x}
	DB			GS;MOV		DX,TSprInfo[SI].height
	SUB			DX,DecHeight
	MOV			DI,CX

	ADD			BX,BX
	ADD			DI,WORD(MultByWidth[BX])

	DB			GS;MOV		BX,TSprInfo[SI].width
	SUB			BX,IncLeft
	SUB			BX,IncRight
	MOV			BP,320
	SUB			BP,BX

	{$IFDEF __BPPROT__}
	MOV			CX,CS
	ADD			CX,SelectorInc
	MOV			ES,CX
	MOV			CX,IncLeft
	ADD			CX,IncRight
	MOV			WORD(ES:@I_LR+2),CX
	{$ELSE}
	MOV			CX,IncLeft
	ADD			CX,IncRight
	MOV			WORD(CS:@I_LR+2),CX
	{$ENDIF}

	MOV			ES,vRAM
	PUSH		DS
	MOV			CX,IncY1
	ADD			CX,IncLeft
	DB			GS;LDS		SI,TSprInfo[SI].PSprite
	ADD			SI,CX

@Y:
	MOV			CX,BX

@X:               {ALIGN 16}
	MOV			AL,[SI]
	INC			SI
	TEST		AL,AL
	JZ			@CERO
	MOV			ES:[DI],AL

@CERO:
	INC			DI
	DEC			CX
	JNZ			@X

@I_LR:
	ADD			SI,$FFFF
	ADD			DI,BP
	DEC			DX
	JNZ     @Y

	POP			DS
	POP			BP

@SALIR:
END;

procedure init;
var
	n:integer;

begin
	GetMem(b,SizeOf(TaBobs));
	for n:=0 to TOTAL do with b^[n] do
		begin
			x:=500+round(n*sin(n*RAD));
			y:=415+round(n*cos(n*RAD));
			z:=round(n*secante(n));
		end;
	GetMem(v,SizeOf(TObject));
	ResetObject(v);
	SetSprite(s,_BOLA_);
end;

procedure done;
begin
	FreeMem(v,SizeOf(TObject));
	Freemem(b,SizeOf(TaBobs));
end;

procedure go;
var
	bb:^TBobs;
	n:integer;

begin
	Precalc12Mult(v);
	bb:=@b^[0];
	for n:=0 to TOTAL do
		begin
			with bb^ do
				begin
					v^.x:=x;v^.y:=y;v^.z:=z;
				end;
			inc(bb);
			RotateVertex12Mult(v);
			with v^ do
				begin
					s.x:=sx;s.y:=sy;
					PutBobClipped(s);
				end;
		end;

	with v^ do
		begin
			inc(balanza);
			if balanza>DEG then balanza:=0;

			dec(deriva,2);
			if deriva<0 then inc(deriva,DEG);

			inc(caida,3);
			if caida>DEG then dec(caida,DEG);
		end;
end;

end.